export enum ACTIONS {
  AUTH_HANDLE_AUTHENTICATION_STATUS = 'AUTH_HANDLE_AUTHENTICATION_STATUS',

  SET_PUSH_NOTIFICATIONS_STATUS = 'SET_PUSH_NOTIFICATIONS_STATUS',
  SET_EMAIL_NOTIFICATIONS_STATUS = 'SET_EMAIL_NOTIFICATIONS_STATUS',

  LOCAL_NOTIFICATIONS_ADD_NOTIFICATION = 'LOCAL_NOTIFICATIONS_ADD_NOTIFICATION',
  LOCAL_NOTIFICATIONS_DELETE_NOTIFICATION = 'LOCAL_NOTIFICATIONS_DELETE_NOTIFICATION',

  NAVIGATION_SET_NAVIGATION_SESSION = 'NAVIGATION_SET_NAVIGATION_SESSION',
  NAVIGATION_CLEAR_NAVIGATION_SESSION = 'NAVIGATION_CLEAR_NAVIGATION_SESSION',

  RECAPTCHA_SET = 'RECAPTCHA_SET',
  RECAPTCHA_DELETE = 'DELETE_DELETE',
  RECAPTCHA_REFRESH = 'RECAPTCHA_REFRESH',

  ORDERS_ADD_DRAFT = 'ORDERS_ADD_DRAFT',
  ORDERS_DELETE_DRAFT = 'ORDERS_DELETE_DRAFT',
  ORDERS_SET_DRAFTS = 'ORDERS_SET_DRAFTS',
  ORDERS_SET_FILTERED_BY_TRIP = 'ORDERS_SET_FILTERED_BY_TRIP',
  ORDERS_UPDATE_FILTERED_BY_TRIP_ORDER = 'ORDERS_UPDATE_FILTERED_BY_TRIP_ORDER',
  ORDERS_HYDRATE_STATE = 'ORDERS_HYDRATE_STATE',
  ORDERS_UPDATE_ONE = 'ORDERS_UPDATE_ONE',
  ORDERS_CLEAR_STATE = 'ORDERS_CLEAR_STATE',

  TRIPS_HYDRATE_STATE = 'TRIPS_HYDRATE_STATE',
  TRIPS_UPDATE_TRIP = 'TRIPS_UPDATE_TRIP',
  TRIPS_SET_FILTERED_BY_ORDER = 'TRIPS_SET_FILTERED_BY_ORDER',
  TRIPS_UPDATE_FILTERED_BY_ORDER_TRIP = 'TRIPS_UPDATE_FILTERED_BY_ORDER_TRIP',
  TRIPS_UPDATE_TRIP_ORDER = 'TRIPS_UPDATE_TRIP_ORDER',
  TRIPS_CLEAR_STATE = 'TRIPS_CLEAR_STATE',

  USER_HYDRATE_PROFILE = 'USER_HYDRATE_PROFILE',
  USER_CLEAR_PROFILE = 'USER_CLEAR_PROFILE',

  CHAT_HYDRATE_CONVERSATIONS = 'CHAT_HYDRATE_CONVERSATIONS',
  CHAT_ADD_NEW_MESSAGE = 'CHAT_ADD_NEW_MESSAGE',
  CHAT_CLEAR_STATE = 'CHAT_CLEAR_STATE',
  SET_NOTIFICATION_SETTINGS = 'SET_NOTIFICATION_SETTINGS',
  SET_LOADER = 'SET_LOADER',
}

export interface IAction {
  type: ACTIONS;
  payload?: any;
}

export const makeAction =
  <T extends ACTIONS, P = null>(type: T) =>
  (payload?: P) => {
    return {
      type,
      payload,
    };
  };
